from direct.showbase.DirectObject import DirectObject
from panda3d.core import TextNode
from direct.gui.OnscreenText import OnscreenText
from direct.gui.DirectGui import DirectEntry
from pandac.PandaModules import Point3

class Teclado(DirectObject) :
    
    def __init__ (self) :
        self.texto = ""
        self.text = TextNode('ip') 
        textNodePath = aspect2d.attachNewNode(self.text) 
        textNodePath.setScale(0.20) 
        self.text.setAlign(TextNode.ACenter)
 
        self.msg = ""
        for i in 'abcdefghijklmnopqrstuvxwyz':
            self.accept(i, getattr(self, 'EventKey%s'%(i.upper())))
            self.accept(i+'-repeat', getattr(self, 'EventKey%s'%(i.upper())))
            
        for i in '0123456789':
            self.accept(i, getattr(self, 'EventKey%s'%i))
            self.accept(i+'-repeat', getattr(self, 'EventKey%s'%i))
            
        self.accept("backspace", self.Apaga)  
        self.accept("backspace-repeat", self.Apaga)
        self.accept("space", self.espaco)
        self.accept("space-repeat", self.espaco)
        self.accept(".", self.ponto)  
        self.accept(".-repeat", self.ponto)
        self.accept("enter", self.Enter)     
        self.accept("-", self.Hifen)
    
    def tira(self):
        for i in 'abcdefghijklmnopqrstuvxwyz':
            self.ignore(i)
            self.ignore(i+'-repeat')
        
        for i in '0123456789':
            self.ignore(i)
            self.ignore(i+'-repeat')
    def limpa(self):
        DirectEntry.enterText("")
    def escreve(self):
        self.text.setText(self.msg)            
        #OnscreenText(text=self.msg, style=1, fg=(1,1,1,1),
         #               pos=(-1.3, 0.0), align=TextNode.ALeft, scale = .25)
    def Enter(self):
        if(len(self.msg) == 0):
            pass
        else:
            self.texto = self.msg
            self.tira()
            self.msg = ""
            self.escreve()
    def Hifen(self):
        self.msg = self.msg+"-"
        return self.escreve()
    def getMsg(self):
        return self.texto
    
    def ponto(self):
        self.msg = self.msg + "."
        return self.escreve()
    def espaco(self):
        self.msg = self.msg + " "
        return self.escreve()
    def Apaga(self):
        self.msg = self.msg[0:len(self.msg)-1]
        return self.escreve()
    def EventKey0(self):
        self.msg = self.msg+'0'
        return self.escreve()
    def EventKey1(self):
        self.msg = self.msg+'1'
        return self.escreve()
    def EventKey2(self):
        self.msg = self.msg+'2'
        return self.escreve()
    def EventKey3(self):
        self.msg = self.msg+'3'
        return self.escreve()
    def EventKey4(self):
        self.msg = self.msg+'4'
        return self.escreve()
    def EventKey5(self):
        self.msg = self.msg+'5'
        return self.escreve()
    def EventKey6(self):
        self.msg = self.msg+'6'
        return self.escreve()
    def EventKey7(self):
        self.msg = self.msg+'7'
        return self.escreve()
    def EventKey8(self):
        self.msg = self.msg+'8'
        return self.escreve()
    def EventKey9(self):
        self.msg = self.msg+'9'
        return self.escreve()
    def EventKeyA(self):
        self.msg = self.msg+"a"
        return self.escreve()
    def EventKeyB(self):
        self.msg = self.msg+"b"
        return self.escreve()
    def EventKeyC(self):
        self.msg = self.msg+"c"
        return self.escreve()
    def EventKeyD(self):
        self.msg = self.msg+"d"
        return self.escreve()
    def EventKeyE(self):
        self.msg = self.msg+"e"
        return self.escreve()
    def EventKeyF(self):
        self.msg = self.msg+"f"
        return self.escreve()
    def EventKeyG(self):
        self.msg = self.msg+"g"
        return self.escreve()
    def EventKeyH(self):
        self.msg = self.msg+"h"
        return self.escreve()
    def EventKeyI(self):
        self.msg = self.msg+"i"
        return self.escreve()
    def EventKeyJ(self):
        self.msg = self.msg+"j"
        return self.escreve()
    def EventKeyK(self):
        self.msg = self.msg+"k"
        return self.escreve()
    def EventKeyL(self):
        self.msg = self.msg+"l"
        return self.escreve()
    def EventKeyM(self):
        self.msg = self.msg+"m"
        return self.escreve()
    def EventKeyN(self):
        self.msg = self.msg+"n"
        return self.escreve()
    def EventKeyO(self):
        self.msg = self.msg+"o"
        return self.escreve()
    def EventKeyP(self):
        self.msg = self.msg+"p"
        return self.escreve()
    def EventKeyQ(self):
        self.msg = self.msg+"q"
        return self.escreve()
    def EventKeyR(self):
        self.msg = self.msg+"r"
        return self.escreve()
    def EventKeyS(self):
        self.msg = self.msg+"s"
        return self.escreve()
    def EventKeyT(self):
        self.msg = self.msg+"t"
        return self.escreve()
    def EventKeyU(self):
        self.msg = self.msg+"u"
        return self.escreve()
    def EventKeyV(self):
        self.msg = self.msg+"v"
        return self.escreve()
    def EventKeyX(self):
        self.msg = self.msg+"x"
        return self.escreve()
    def EventKeyW(self):
        self.msg = self.msg+"w"
        return self.escreve()
    def EventKeyY(self):
        self.msg = self.msg+"y"
        return self.escreve()
    def EventKeyZ(self):
        self.msg = self.msg+"z"
        return self.escreve()


        
        
        