
class EstadoMemento(object):

    @staticmethod
    def salvaEstado(personagens):
        posicoes = [] 
        rotacoes = []
        for p in personagens:
            posicoes.append(p.modelo.getPos())
            rotacoes.append(p.modelo.getHpr())
        posicoes.append(base.camera.getPos())
        rotacoes.append(base.camera.getHpr())
        
        return (posicoes, rotacoes)
        
    @staticmethod
    def recuperaEstado(personagens, estado):
        posicoes, rotacoes = estado
        for i in range(len(personagens)):
            personagens[i].modelo.setPos(posicoes[i])
            personagens[i].modelo.setHpr(rotacoes[i])
        base.camera.setPos(posicoes.pop())
        base.camera.setHpr(rotacoes.pop())
    
