from Fila import Fila

class Grafo(object):

    def __init__(self):
        self.matriz = []
        arquivo = open("../modelos/grafoMiniGame.txt", "r")
        linha = arquivo.readline()
        self.numeroVertices = eval(linha)
        self.__inicializaGrafo()
        self.__montaGrafo(arquivo)
    
    def insereAresta(self, origem, destino):
        self.matriz[origem][destino] = 1
            
    def temAresta(self, x, y):
        if (self.matriz[x][y] == 1):
            return True
        return False 
    
    def __montaGrafo(self, arquivo):
        while (True):
            linha = arquivo.readline()
            x, y = linha.split()
            x = eval(x)
            y = eval(y)
            if ((x + y) == 0):
                break
            self.insereAresta(x-1, y-1)
    
    def __inicializaGrafo(self):
        for i in range(self.numeroVertices):
            linha = []
            for j in range(self.numeroVertices):
                linha.append(0)
            self.matriz.append(linha)

    def getVizinhos(self, vertice):
        vizinhos = []
        for i in range(self.numeroVertices) :
            if (self.temAresta(vertice, i)) :
                vizinhos.append(i)
        return vizinhos

    def buscaLargura(self, s):
        parnt = []
        dist = []

        for i in range(self.numeroVertices):
            dist.append(self.numeroVertices)
            parnt.append(0)

        fila = Fila(self.numeroVertices*self.numeroVertices)
        dist[s] = 0
        parnt[s] = s

        fila.adicionaFila(s)

        while (fila.filaVazia() is False):
            v = fila.removeFila()
            for w in range (self.numeroVertices):
                if (self.temAresta(v, w) and dist[w] == self.numeroVertices):
                    parnt[w] = v
                    dist[w] = dist[v] + 1
                    fila.adicionaFila(w)
        return parnt, dist
